﻿using System;
using BlazorApp.Models;
using BlazorApp.Components;
using Microsoft.AspNetCore.Components;

namespace BlazorApp.Components
{
	public partial class InventoryItem
	{
        [Parameter]
        public int Index { get; set; }

        [Parameter]
        public Item Item { get; set; }

        [Parameter]
        public bool NoDrop { get; set; }

        [CascadingParameter]
        public InventoryComp Parent { get; set; }

        internal void OnDragEnter()
        {
            if (NoDrop)
            {
                return;
            }

        }

        internal void OnDragLeave()
        {
            if (NoDrop)
            {
                return;
            }

        }

        internal void OnDrop()
        {
            if (NoDrop)
            {
                return;
            }

            Parent.InventoryItems[Parent.CurrentDragIndex] = this.Item;
            this.Item = Parent.CurrentDragItem;
            Parent.InventoryItems[this.Index] = this.Item;
        }

        private void OnDragStart()
        {
            Parent.CurrentDragIndex = this.Index;
            Parent.CurrentDragItem = this.Item;
        }
    }
}

